<template>
  <div class="virtual-objects">
    <q-page padding>
      <h6>Virtual Objects</h6>

      <!-- Virtual Objects Grid -->
      <div class="q-gutter-md q-pa-md">
        <q-card
          v-for="artifact in artifacts"
          :key="artifact.name"
          class="my-card"
        >
          <q-card-section>
            <div class="text-h6">{{ artifact.name }}</div>
          </q-card-section>

          <q-card-section>
            <q-card-section>
              <div class="q-gutter-sm row justify-start">
                <q-btn
                  flat
                  @click="() => showDescriptor(artifact.name, 'yaml')"
                  icon="description"
                  label="YAML"
                ></q-btn>
                <q-btn
                  flat
                  @click="() => showDescriptor(artifact.name, 'py')"
                  icon="code"
                  label="Python"
                ></q-btn>
                <q-btn
                  flat
                  @click="() => showDescriptor(artifact.name, 'json')"
                  icon="settings_ethernet"
                  label="JSON"
                ></q-btn>
              </div>
            </q-card-section>
          </q-card-section>

          <q-card-section>
            <div><strong>Description:</strong> {{ artifact.description }}</div>
            <div><strong>Version:</strong> {{ artifact.version }}</div>
            <div>
              <strong>Implementer:</strong> {{ artifact.specImplementer }}
            </div>
            <div><strong>Type:</strong> {{ artifact.specType }}</div>
          </q-card-section>
          <q-card-section>
            <q-btn @click="() => showDetails(artifact)">View Details</q-btn>
          </q-card-section>
        </q-card>
      </div>
    </q-page>

    <!-- Details Dialog -->
    <q-dialog v-model="showPopover">
      <q-card>
        <q-card-section>
          <div class="text-h6">Details: {{ currentVO.name }}</div>
          <div class="q-mt-md">
            <p><strong>Description:</strong> {{ currentVO.description }}</p>
            <p><strong>Type:</strong> {{ currentVO.type }}</p>
            <p><strong>Version:</strong> {{ currentVO.version }}</p>
            <p v-for="(value, key) in currentVO.annotations" :key="key">
              <strong>{{ key }}:</strong> {{ value }}
            </p>
            <div>
              <strong>Maintainers:</strong>
              <ul>
                <li
                  v-for="maintainer in currentVO.maintainers"
                  :key="maintainer.name"
                >
                  {{ maintainer.name }}
                </li>
              </ul>
            </div>
          </div>
        </q-card-section>
        <q-card-actions align="right">
          <q-btn flat label="Close" color="primary" v-close-popup />
        </q-card-actions>
      </q-card>
    </q-dialog>

    <!-- Descriptor Dialog -->
    <q-dialog v-model="showDescriptorDialog">
      <q-card style="width: 800px; max-width: 800px">
        <q-card-section class="q-pa-md">
          <div class="text-h6">{{ descriptorTitle }}</div>
          <pre>{{ descriptorContent }}</pre>
        </q-card-section>
        <q-card-actions align="right">
          <q-btn flat label="Close" color="primary" v-close-popup />
        </q-card-actions>
      </q-card>
    </q-dialog>
  </div>
</template>

<script setup lang="ts">
import { ref, onMounted } from 'vue';
import { useFetchArtifacts } from '../hooks/artifacts';
import { useFetchDescriptors } from '../hooks/descriptors';
import {
  QPage,
  QCard,
  QCardSection,
  QBtn,
  QDialog,
  QCardActions,
} from 'quasar';
// import { useRouter } from 'vue-router';

interface Artifact {
  ref: string;
  spec: {
    type: string;
    implementer: string;
    target: {
      name: string;
      version: string;
    };
  };
}

// const router = useRouter();
const showPopover = ref(false);
const showDescriptorDialog = ref(false);
const descriptorTitle = ref('');
const descriptorContent = ref('');
const currentVO = ref({});
const { artifacts, fetchArtifacts } = useFetchArtifacts();
const { descriptor, fetchDescriptor } = useFetchDescriptors();

async function showDescriptor(id, fileType: string) {
  await fetchDescriptor(id);
  console.log(descriptor.value);

  const selectedDescriptor = descriptor.value.find((desc) =>
    desc.fileName.endsWith(fileType),
  );
  if (descriptor) {
    descriptorTitle.value = selectedDescriptor.fileName;
    descriptorContent.value = selectedDescriptor.content;
    showDescriptorDialog.value = true;
  }
}

function showDetails(vo: Artifact) {
  currentVO.value = vo;
  showPopover.value = true;
}

// function goToThreeFileFormat(voName: string) {
//   router.push(`/dashboard/software_artifacts/vo/${voName}`); // Adjust URL as needed
// }
onMounted(async () => {
  await fetchArtifacts('VO');
});
</script>

<style scoped>
.virtual-objects .my-card {
  width: 200px;
  /* Adjust size as needed */
}

.q-gutter-md > .q-card {
  display: inline-block;
  /* Arrange cards in a grid */
}
</style>
